Index: src/Actions/GlobalListOfActions.hpp
===================================================================
--- src/Actions/GlobalListOfActions.hpp	(revision 43c79a35f2709709e8cc7d2bc7fee569ae9bff5b)
+++ src/Actions/GlobalListOfActions.hpp	(revision 70bce952fe074f8df663ea61ed19170aefbb6afd)
@@ -113,4 +113,5 @@
   (SelectionAtomById) \
   (SelectionAtomByOrder) \
+  (SelectionAllShapes) \
   (FragmentationFragmentation) \
   (FillRegularGrid) \
Index: src/Actions/Makefile.am
===================================================================
--- src/Actions/Makefile.am	(revision 43c79a35f2709709e8cc7d2bc7fee569ae9bff5b)
+++ src/Actions/Makefile.am	(revision 70bce952fe074f8df663ea61ed19170aefbb6afd)
@@ -60,4 +60,5 @@
   ${SELECTIONATOMACTIONSOURCE} \
   ${SELECTIONMOLECULEACTIONSOURCE} \
+  ${SELECTIONSHAPEACTIONSOURCE} \
   ${SHAPEACTIONSOURCE} \
   ${TESSELATIONACTIONSOURCE} \
@@ -77,4 +78,5 @@
   ${SELECTIONATOMACTIONHEADER} \
   ${SELECTIONMOLECULEACTIONHEADER} \
+  ${SELECTIONSHAPEACTIONHEADER} \
   ${SHAPEACTIONHEADER} \
   ${TESSELATIONACTIONHEADER} \
@@ -94,4 +96,5 @@
   ${SELECTIONATOMACTIONDEFS} \
   ${SELECTIONMOLECULEACTIONDEFS} \
+  ${SELECTIONSHAPEACTIONDEFS} \
   ${SHAPEACTIONDEFS} \
   ${TESSELATIONACTIONDEFS} \
@@ -395,4 +398,11 @@
   Actions/SelectionAction/Molecules/NotMoleculeByOrderAction.def \
   Actions/SelectionAction/Molecules/NotMoleculeOfAtomAction.def
+                 
+SELECTIONSHAPEACTIONSOURCE = \
+  Actions/SelectionAction/Shapes/AllShapesAction.cpp
+SELECTIONSHAPEACTIONHEADER = \
+  Actions/SelectionAction/Shapes/AllShapesAction.hpp
+SELECTIONSHAPEACTIONDEFS = \
+  Actions/SelectionAction/Shapes/AllShapesAction.def
 	
 SHAPEACTIONSOURCE = \
Index: src/Actions/SelectionAction/Shapes/AllShapesAction.cpp
===================================================================
--- src/Actions/SelectionAction/Shapes/AllShapesAction.cpp	(revision 70bce952fe074f8df663ea61ed19170aefbb6afd)
+++ src/Actions/SelectionAction/Shapes/AllShapesAction.cpp	(revision 70bce952fe074f8df663ea61ed19170aefbb6afd)
@@ -0,0 +1,85 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010-2012 University of Bonn. All rights reserved.
+ *
+ *
+ *   This file is part of MoleCuilder.
+ *
+ *    MoleCuilder is free software: you can redistribute it and/or modify
+ *    it under the terms of the GNU General Public License as published by
+ *    the Free Software Foundation, either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    MoleCuilder is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ *
+ *    You should have received a copy of the GNU General Public License
+ *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/*
+ * AllShapesAction.cpp
+ *
+ *  Created on: Sep 14, 2012
+ *      Author: ankele
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "Shapes/ShapeRegistry.hpp"
+
+#include <boost/foreach.hpp>
+#include <iostream>
+#include <string>
+
+#include "AllShapesAction.hpp"
+
+using namespace MoleCuilder;
+
+// and construct the stuff
+#include "AllShapesAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr SelectionAllShapesAction::performCall() {
+  std::vector<Shape *> selectedShapes= ShapeRegistry::getInstance().getSelectedShapes();
+  LOG(1, "Selecting all shapes.");
+  ShapeRegistry::getInstance().selectAllShapes();
+  LOG(0, ShapeRegistry::getInstance().countSelectedShapes() << " shapes selected.");
+  return Action::state_ptr(new SelectionAllShapesState(selectedShapes,params));
+}
+
+Action::state_ptr SelectionAllShapesAction::performUndo(Action::state_ptr _state) {
+  SelectionAllShapesState *state = assert_cast<SelectionAllShapesState*>(_state.get());
+
+  ShapeRegistry::getInstance().unselectAllShapes();
+
+  BOOST_FOREACH(Shape *shape, state->selectedShapes)
+  ShapeRegistry::getInstance().selectShape(shape);
+
+  return Action::state_ptr(_state);
+}
+
+Action::state_ptr SelectionAllShapesAction::performRedo(Action::state_ptr _state){
+  //SelectionAllShapesState *state = assert_cast<SelectionAllShapesState*>(_state.get());
+
+  ShapeRegistry::getInstance().selectAllShapes();
+
+  return Action::state_ptr(_state);
+}
+
+bool SelectionAllShapesAction::canUndo() {
+  return true;
+}
+
+bool SelectionAllShapesAction::shouldUndo() {
+  return true;
+}
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/Shapes/AllShapesAction.def
===================================================================
--- src/Actions/SelectionAction/Shapes/AllShapesAction.def	(revision 70bce952fe074f8df663ea61ed19170aefbb6afd)
+++ src/Actions/SelectionAction/Shapes/AllShapesAction.def	(revision 70bce952fe074f8df663ea61ed19170aefbb6afd)
@@ -0,0 +1,36 @@
+/*
+ * AllShapesAction.def
+ *
+ *  Created on: Sep 14, 2012
+ *      Author: ankele
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+
+#include "Parameters/Validators/DummyValidator.hpp"
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required, use (NOPARAM_DEFAULT) for each (undefined) default value
+#undef paramtypes
+#undef paramtokens
+#undef paramdescriptions
+#undef paramdefaults
+#undef paramreferences
+#undef paramvalids
+
+#define statetypes (std::vector<Shape*>)
+#define statereferences (selectedShapes)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define MENUNAME "selection"
+#define MENUPOSITION 25
+#define ACTIONNAME AllShapes
+#define TOKEN "select-all-shapes"
+
+
+// finally the information stored in the ActionTrait specialization
+#define DESCRIPTION "select all shapes"
+#undef SHORTFORM
Index: src/Actions/SelectionAction/Shapes/AllShapesAction.hpp
===================================================================
--- src/Actions/SelectionAction/Shapes/AllShapesAction.hpp	(revision 70bce952fe074f8df663ea61ed19170aefbb6afd)
+++ src/Actions/SelectionAction/Shapes/AllShapesAction.hpp	(revision 70bce952fe074f8df663ea61ed19170aefbb6afd)
@@ -0,0 +1,22 @@
+/*
+ * AllShapesAction.hpp
+ *
+ *  Created on: Sep 14, 2012
+ *      Author: ankele
+ */
+
+#ifndef ALLSHAPESACTION_HPP_
+#define ALLSHAPESACTION_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include "Actions/Action.hpp"
+
+#include "AllShapesAction.def"
+#include "Action_impl_header.hpp"
+
+#endif /* ALLSHAPESACTION_HPP_ */
